//
//  ESPCourse.h
//  CourseImporter
//
//  Created by John Pannell on 7/10/14.
//  Copyright (c) 2014 John Pannell. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreData/CoreData.h>

@class ESPFacility, ESPTee;

@interface ESPCourse : NSManagedObject

@property (nonatomic, retain) NSString * courseID;
@property (nonatomic, retain) NSString * courseName;
@property (nonatomic, retain) NSDate * lastUpdated;
@property (nonatomic, retain) NSNumber * numberOfHoles;
@property (nonatomic, retain) NSNumber * par;
@property (nonatomic, retain) ESPFacility *facility;
@property (nonatomic, retain) NSSet *games;
@property (nonatomic, retain) NSSet *tees;
@end

@interface ESPCourse (CoreDataGeneratedAccessors)

- (void)addGamesObject:(NSManagedObject *)value;
- (void)removeGamesObject:(NSManagedObject *)value;
- (void)addGames:(NSSet *)values;
- (void)removeGames:(NSSet *)values;

- (void)addTeesObject:(ESPTee *)value;
- (void)removeTeesObject:(ESPTee *)value;
- (void)addTees:(NSSet *)values;
- (void)removeTees:(NSSet *)values;

@end
