//
//  ESPFacility.h
//  CourseImporter
//
//  Created by John Pannell on 7/10/14.
//  Copyright (c) 2014 John Pannell. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreData/CoreData.h>

@class ESPCourse;

@interface ESPFacility : NSManagedObject

@property (nonatomic, retain) NSString * address;
@property (nonatomic, retain) NSString * city;
@property (nonatomic, retain) NSString * email;
@property (nonatomic, retain) NSString * facilityID;
@property (nonatomic, retain) NSDate * lastUpdated;
@property (nonatomic, retain) NSNumber * latitude;
@property (nonatomic, retain) NSNumber * longitude;
@property (nonatomic, retain) NSString * name;
@property (nonatomic, retain) NSString * phone;
@property (nonatomic, retain) NSString * postalCode;
@property (nonatomic, retain) NSString * state;
@property (nonatomic, retain) NSString * website;
@property (nonatomic, retain) NSSet *courses;
@end

@interface ESPFacility (CoreDataGeneratedAccessors)

- (void)addCoursesObject:(ESPCourse *)value;
- (void)removeCoursesObject:(ESPCourse *)value;
- (void)addCourses:(NSSet *)values;
- (void)removeCourses:(NSSet *)values;

@end
