//
//  ESPRealmObjects.h
//  CourseImporter
//
//  Created by John Pannell on 7/21/14.
//  Copyright (c) 2014 John Pannell. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <Realm/Realm.h>

RLM_ARRAY_TYPE(ESPRealmCourse) // define RLMArray<ESPRealmCourse>
RLM_ARRAY_TYPE(ESPRealmTee) // define RLMArray<ESPRealmTee>
RLM_ARRAY_TYPE(ESPRealmHole) // define RLMArray<ESPRealmHole>

@interface ESPRealmFacility : RLMObject

@property  NSString * address;
@property  NSString * city;
@property  NSString * email;
@property  NSString * facilityID;
@property  NSDate * lastUpdated;
@property  float latitude;
@property  float longitude;
@property  NSString * name;
@property  NSString * phone;
@property  NSString * postalCode;
@property  NSString * state;
@property  NSString * website;
@property  RLMArray<ESPRealmCourse> *courses;

@end

@interface ESPRealmCourse : RLMObject

@property  NSString * courseID;
@property  NSString * courseName;
@property  NSDate * lastUpdated;
@property  int numberOfHoles;
@property  int par;
@property  ESPRealmFacility *facility;
@property  RLMArray<ESPRealmTee> *tees;

@end

@interface ESPRealmTee : RLMObject

@property  NSString * color;
@property  NSDate * dateConfirmed;
@property  NSString * name;
@property  int par;
@property  float rating;
@property  float slope;
@property  NSString * teeID;
@property  int totalDistance;
@property  ESPRealmCourse *course;
@property  RLMArray<ESPRealmHole> *holes;

@end

@interface ESPRealmHole : RLMObject

@property  int distance;
@property  int handicap;
@property  int holeNumber;
@property  int par;
@property  ESPRealmTee *tee;

@end
