//
//  ESPTee.h
//  CourseImporter
//
//  Created by John Pannell on 7/10/14.
//  Copyright (c) 2014 John Pannell. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreData/CoreData.h>

@class ESPCourse, ESPHole;

@interface ESPTee : NSManagedObject

@property (nonatomic, retain) NSString * color;
@property (nonatomic, retain) NSDate * dateConfirmed;
@property (nonatomic, retain) NSString * name;
@property (nonatomic, retain) NSNumber * par;
@property (nonatomic, retain) NSNumber * rating;
@property (nonatomic, retain) NSNumber * slope;
@property (nonatomic, retain) NSString * teeID;
@property (nonatomic, retain) NSNumber * totalDistance;
@property (nonatomic, retain) ESPCourse *course;
@property (nonatomic, retain) NSSet *holes;
@property (nonatomic, retain) NSSet *rounds;
@end

@interface ESPTee (CoreDataGeneratedAccessors)

- (void)addHolesObject:(ESPHole *)value;
- (void)removeHolesObject:(ESPHole *)value;
- (void)addHoles:(NSSet *)values;
- (void)removeHoles:(NSSet *)values;

- (void)addRoundsObject:(NSManagedObject *)value;
- (void)removeRoundsObject:(NSManagedObject *)value;
- (void)addRounds:(NSSet *)values;
- (void)removeRounds:(NSSet *)values;

@end
